define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'user/user/index',
                    add_url: 'user/user/add',
                    edit_url: 'user/user/edit',
                    del_url: 'user/user/del',
                    multi_url: 'user/user/multi',
                    table: 'user',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id'), sortable: true},
                        {field: 'pid', title: __('邀请人'),width: 50,formatter: function (value, row, index){
                            return (value == 0 ? '无' : '<a href="user/user/index?id='+value+'" class="btn-dialog">'+value+'</a>');
                        }},
                        {field: 'vip', title: __('VIP'), formatter: Table.api.formatter.toggle, searchList: {'1': __('是'), '0': __('否')}},
                        {field: 'zan', title: __('被赞上限')},
                        {field: 'auto', title: __('后台监控'), formatter: Table.api.formatter.toggle, searchList: {'1': __('是'), '0': __('否')} ,visible: false},
                        {field: 'jb', title: __('脚本点赞'), formatter: Table.api.formatter.toggle, searchList: {'1': __('是'), '0': __('否')}},
                        {field: 'qq', title: __('QQ'), operate: 'LIKE'},
                        {field: 'nickname', title: __('Nickname'), operate: 'LIKE'},
                        {field: 'avatar', title: __('Avatar'), events: Table.api.events.image, formatter: Table.api.formatter.image, operate: false},
                        {field: 'score', title: __('Score'), operate: 'BETWEEN', sortable: true},
                        {field: 'successions', title: __('Successions'), operate: 'BETWEEN', sortable: true, visible: false},
                        {field: 'maxsuccessions', title: __('Maxsuccessions'), visible: false, operate: 'BETWEEN', sortable: true, visible: false},
                        {field: 'logintime', title: __('Logintime'), formatter: Table.api.formatter.datetime, operate: 'RANGE', addclass: 'datetimerange', sortable: true, visible: false},
                        {field: 'loginip', title: __('Loginip'), formatter: Table.api.formatter.search, visible: false},
                        {field: 'jointime', title: __('Jointime'), formatter: Table.api.formatter.datetime, operate: 'RANGE', addclass: 'datetimerange', sortable: true, visible: false},
                        {field: 'joinip', title: __('Joinip'), formatter: Table.api.formatter.search, visible: false},
                        {field: 'status', title: __('Status'), formatter: Table.api.formatter.status, searchList: {normal: __('Normal'), hidden: __('Hidden')}},
                        {field: 'vip_time', title: __('VIP到期时间'),formatter: function (value, row, index){
                            return (!value ? '无' : Table.api.formatter.datetime(value));
                        }},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        zan: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});